/*
 *                   jfjji,.           H A M M E R H E A D  S H A R K W A R E
 *                  ,#######EL:                  http://www.hhsw.de
 *                   .,j######Kj       
 *                    ;W########G:     This  code  is  free software; you can
 *                   j#####G ,D#L:     redistribute it and/or modify it under
 *             .,;;,G#####D.           the  terms  of  the GNU General Public
 *           jE##########G             License   as  published  by  the  Free
 *             .,W######D.             Software  Foundation; either version 2
 *             :L#####K##G             of  the  License,  or (at your option)
 *           .f#####G;.t##:            any later version.
 *         ;L###ELi.    ,D,            
 *       iEEGWj                        This  code  is distributed in the hope
 *      tW;                            that  it  will  be useful, but without
 *     jf                              any warranty; without even the implied
 *    .Kt                              warranty of merchantability or fitness
 *    i:                               for  a particular purpose. See the GNU
 *    ;                                General   Public   License   for  more
 *    .                                details (http://www.gnu.org).
 *
 * @author mf@hhsw.de
 * @version 20040712
 */
#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <iostream.h>

#include "bbdock.hh"
#include "bbdockrc.hh"

/*
 * Fetch an icon from the resource configuration file,
 * the idea of this function is to get rid of the
 * BBDockRC object after loading the icon
 *
 * @param binary - name of the currently running binary
 */
BBDock *loadrc( char *binary )
{
	BBDockRC	rc( binary );

	return rc.load();
}

/*
 * Entry point
 */
int main( int argc, char **argv )
{
	BBDock	*dock;

	if( argc & 1 &&
		(dock = loadrc( *argv )) )
	{
		dock->run();
		delete dock;
	}
	else
		for( char *binary = *argv; --argc; )
			if( **(++argv) != '-' )
			{
				char	*img;
				char	*cmd;

				if( (img = strtok( *argv, ":" )) &&
					(cmd = strtok( NULL, "" )) )
				{
					switch( fork() )
					{
						case -1:
							return -1;
						case 0:
							dock = new BBDock( img, cmd );
							dock->run();
							delete dock;
							return 0;
					}
				}
				else
				{
					cout << "Invalid argument" << endl;
				}
			}
			else
				switch( *((*argv)+1) )
				{
					default:
					case '?':
					case 'h':
						cout << "usage: " << binary << 
							" [-h] PNGFILE:COMMAND..." << endl;
						return 0;
					case 'v':
						cout << "bbdock, version 0.01 <mf@hhsw.de>" << endl;
						return 0;
				}

	return 0;
}
